#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

typedef struct
{
  char name[21];
  float balance;
  int accNo;
}
CustAccount;

CustAccount accounts[] = {
  {"White", 123.5, 1234},
  {"Barry", -12.75, 1235},
  {"Agnew", 24.55, 1236},
  {"Achison", 12.45, 1237},
  {"Barry", -38.49, 1238},
  {"Brown", -18.23, 1239},
  {"Cunningham", 19.32, 1240}
};


int
compAccNo (const void *p1, const void *p2)
{
  return ((CustAccount *) p1)->accNo - ((CustAccount *) p2)->accNo;
}

int
compName (const void *p1, const void *p2)
{
  return strcmp (((CustAccount *) p1)->name, ((CustAccount *) p2)->name);
}

void
printAccount (CustAccount * a)
{
  if (a)
    printf ("Name: %20s\t AccNo: %d\t Balance: %f\n", a->name,
	    a->accNo, a->balance);
  else
    printf ("Null account\n");
}

CustAccount *
findByName (const char *name)
{
  CustAccount reference;
  strcpy (reference.name, name);
  return bsearch (&reference, accounts,
		  sizeof (accounts) / sizeof (*accounts), sizeof (*accounts),
		  compName);
}

CustAccount *
findByAccNo (int accNo)
{
  CustAccount reference;
  reference.accNo = accNo;
  return bsearch (&reference, accounts,
		  sizeof (accounts) / sizeof (*accounts), sizeof (*accounts),
		  compAccNo);
}

void
displayAccount (CustAccount * a, unsigned int n)
{
  unsigned int i;
  printf ("Printing array\n");
  for (i = 0; i < n; i++)
    printAccount (a + i);
}

int
main (int argc, char *argv[])
{
  /* sort by name */
  qsort (accounts, sizeof (accounts) / sizeof (*accounts), sizeof (*accounts),
	 compName);
  printf ("Accounts sorted by name:\n");
  displayAccount (accounts, sizeof (accounts) / sizeof (*accounts));
  /* search by name */
  printf ("Searching for White:\n");
  printAccount (findByName ("White"));
  printf ("Searching for Green:\n");
  printAccount (findByName ("Green"));
  /* sort by accNo */
  qsort (accounts,
	 sizeof (accounts) /
	 sizeof (*accounts), sizeof (*accounts), compAccNo);
  printf ("Accounts sorted by number:\n");
  displayAccount (accounts, sizeof (accounts) / sizeof (*accounts));
  /* search by name (will not work) */
  printf ("Searching for White:\n");
  printAccount (findByName ("White"));
  printf ("Searching for Green:\n");
  printAccount (findByName ("Green"));
  /* search by account number */
  printf ("Searching for 1234:\n");
  printAccount (findByAccNo (1234));
  printf ("Searching for 15:\n");
  printAccount (findByAccNo (15));
  return 0;
}
