#include <stdio.h>
#include <string.h>

typedef struct
{
  char name[21];
  float balance;
  int accNo;
}
CustAccount;

void
printAccount (CustAccount * a)
{
  if (a)
    printf ("Name: %20s\t AccNo: %d\t Balance: %.2f\n", a->name,
	    a->accNo, a->balance);
  else
    printf ("Null account\n");
}

void
display (CustAccount * a, unsigned int n)
{
  unsigned int i;
  printf ("Printing array\n");
  for (i = 0; i < n; i++)
    printAccount (a + i);
}

void
swap (CustAccount * a, CustAccount * b)
{
  CustAccount tmp;
  tmp = *a;
  *a = *b;
  *b = tmp;
}

void
bubblesort (CustAccount * a, unsigned int n,
	    int (*comp) (const CustAccount *, const CustAccount *))
{
  unsigned int i, j;
  for (i = n - 1; i > 0; i--)
    for (j = 0; j < i; j++)
      if (comp (a + j, a + j + 1) > 0)
	swap (a + j, a + j + 1);
}

int
compAccNo (const CustAccount * p1, const CustAccount * p2)
{
  return p1->accNo - p2->accNo;
}

int
compName (const CustAccount * p1, const CustAccount * p2)
{
  return strcmp (p1->name, p2->name);
}

int
compBalance (const CustAccount * p1, const CustAccount * p2)
{
  if(p1->balance>p2->balance)
    return -1;
  else
  if(p1->balance<p2->balance)
    return 1;
  else
    return 0;
}


int
main ()
{
  CustAccount accounts[] = {
    {"White", 123.5, 1234},
    {"Barry", -12.75, 1235},
    {"Agnew", 24.55, 1236},
    {"Achison", 12.45, 1237},
    {"Barry", -38.49, 1238},
    {"Brown", -18.23, 1239},
    {"Cunningham", 19.32, 1240}
  };

  display (accounts, sizeof (accounts) / sizeof (*accounts));
  bubblesort (accounts, sizeof (accounts) / sizeof (*accounts), compName);
  display (accounts, sizeof (accounts) / sizeof (*accounts));
  bubblesort (accounts, sizeof (accounts) / sizeof (*accounts), compAccNo);
  display (accounts, sizeof (accounts) / sizeof (*accounts));
  bubblesort (accounts, sizeof (accounts) / sizeof (*accounts), compBalance);
  display (accounts, sizeof (accounts) / sizeof (*accounts));
  return 0;
}
