#include <stdio.h>
#include <string.h>

typedef struct
{
  char name[21];
  float balance;
  int accNo;
}
CustAccount;

void
printAccount (CustAccount * a)
{
  if (a)
    printf ("Name: %20s\t AccNo: %d\t Balance: %.2f\n", a->name,
	    a->accNo, a->balance);
  else
    printf ("Null account\n");
}

void
displayAccount (CustAccount * a, unsigned int n)
{
  unsigned int i;
  printf ("Printing array\n");
  for (i = 0; i < n; i++)
    printAccount (a + i);
}

void
displayNumber (int *a, unsigned int n)
{
  unsigned int i;
  printf ("Printing array\n");
  for (i = 0; i < n; i++)
    printf ("%d\n", a[i]);
}

void
swap (void *a, void *b, unsigned int size)
{
  char tmp;
  unsigned int i;
  for (i = 0; i < size; i++)
    {
      tmp = *((char *) a + i);
      *((char *) a + i) = *((char *) b + i);
      *((char *) b + i) = tmp;
    }
}

void
bubblesort (void *base, unsigned int nmemb, unsigned int size,
	    int (*comp) (const void *, const void *))
{
  unsigned int i, j;
  for (i = nmemb - 1; i > 0; i--)
    for (j = 0; j < i; j++)
      if (comp ((char *) base + j * size, (char *) base + (j + 1) * size) > 0)
	swap ((char *) base + j * size, (char *) base + (j + 1) * size, size);
}

int
compAccNo (const void *p1, const void *p2)
{
  return ((CustAccount *) p1)->accNo - ((CustAccount *) p2)->accNo;
}

int
compName (const void *p1, const void *p2)
{
  return strcmp (((CustAccount *) p1)->name, ((CustAccount *) p2)->name);
}

int
compNum (const void *p1, const void *p2)
{
  return *((int *) p1) - *((int *) p2);
}


int
main ()
{
  CustAccount accounts[] = {
    {"White", 123.5, 1234},
    {"Barry", -12.75, 1235},
    {"Agnew", 24.55, 1236},
    {"Achison", 12.45, 1237},
    {"Barry", -38.49, 1238},
    {"Brown", -18.23, 1239},
    {"Cunningham", 19.32, 1240}
  };
  int numbers[] = { 15, 128, 3, 27, 32, 56, 1, 87 };

  displayAccount (accounts, sizeof (accounts) / sizeof (*accounts));
  bubblesort (accounts, sizeof (accounts) / sizeof (*accounts),
	      sizeof (*accounts), compName);
  displayAccount (accounts, sizeof (accounts) / sizeof (*accounts));
  bubblesort (accounts, sizeof (accounts) / sizeof (*accounts),
	      sizeof (*accounts), compAccNo);
  displayAccount (accounts, sizeof (accounts) / sizeof (*accounts));

  displayNumber (numbers, sizeof (numbers) / sizeof (*numbers));
  bubblesort (numbers, sizeof (numbers) / sizeof (*numbers),
	      sizeof (*numbers), compNum);
  displayNumber (numbers, sizeof (numbers) / sizeof (*numbers));

  return 0;
}
