#include <stdio.h>

/* Search for what in an integer array
   sorted in the ascending order.
   low points to the first number in the array
   high points just after the end of the array 
   Return the pointer to the number found
   or zero, if the number is not in the array */
   
int *
binarySearch (int what, int *low, int *high)
{
  while (high > low)
    {
      int *middle = low + (high - low) / 2;
      if (*middle == what)
	return middle;
      else if (*middle > what)
	high = middle;
      else
	low = middle + 1;
    }
  return NULL;
}

void
search (int number, int *low, int *high)
{
  if (binarySearch (number, low, high))
    printf ("%d found\n",number);
  else
    printf ("%d not found\n",number);
}


int
main ()
{
  int numbers[] = { 1, 3, 15, 27, 32, 56, 87, 128 };
  search (87, numbers, numbers + sizeof (numbers) / sizeof (*numbers));
  search (56, numbers, numbers + sizeof (numbers) / sizeof (*numbers));
  search (16, numbers, numbers + sizeof (numbers) / sizeof (*numbers));
  return 0;
}
